import Day8Lib (processInput1, processInput2)
import System.IO
import Test.HUnit

testCases1 =
  [ ("data/input080.txt", 21),
    ("data/input081.txt", 1779)
  ]

testCase1 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput1 contents
    )

testCases2 =
  [ ("data/input080.txt", 8),
    ("data/input081.txt", 172224)
  ]

testCase2 (file, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual ("input test: " ++ file) result $ processInput2 contents
    )

tests =
  TestList $
    [TestCase (testCase1 c) | c <- testCases1]
      ++ [TestCase (testCase2 c) | c <- testCases2]

main :: IO ()
main = do
  runTestTT tests
  return ()
