import Day8Lib
import Test.HUnit

tVisible1 =
  TestCase $
    assertEqual
      "visible 1"
      [True, False, False, True, False]
      (lVisible [3, 0, 3, 7, 3])

tVisible2 =
  TestCase $
    assertEqual
      "visible 2"
      [True, False, False, False, False]
      (lVisible [6, 5, 3, 3, 2])

tVisible3 =
  TestCase $
    assertEqual
      "visible 3"
      [True, False, True, False, True]
      (lVisible [3, 3, 5, 4, 9])

tRscore1 =
  TestCase $
    assertEqual
      "rScore 1"
      [0, 1, 1, 3, 1, 1, 6]
      (reverse . rScore . reverse $ [0, 0, 0, 1, 1, 0, 2])

tRscore2 =
  TestCase $
    assertEqual
      "rscore 2"
      [2, 1, 1, 1, 0]
      (rScore [3, 0, 3, 7, 3])

tRscore3 =
  TestCase $
    assertEqual
      "rscore 3"
      [4, 3, 1, 1, 0]
      (rScore [6, 5, 3, 3, 2])

tRscore4 =
  TestCase $
    assertEqual
      "rscore 4"
      [1, 1, 2, 1, 0]
      (rScore [3, 3, 5, 4, 9])

tests =
  TestList $
    [ tVisible1,
      tVisible2,
      tVisible3,
      tRscore1,
      tRscore2,
      tRscore3,
      tRscore4
    ]

main :: IO ()
main = do
  runTestTT tests
  return ()
