import Day13Lib
import Test.HUnit
import Text.Parsec

parseTests =
  [ parse parseNumber "" "1"
      ~?= Right (Num 1),
    parse parseNumber "" "10"
      ~?= Right (Num 10),
    parse parseList "" "[]"
      ~?= Right (List []),
    parse parseList "" "[1,2]"
      ~?= Right (List [Num 1, Num 2]),
    parse parseList "" "[1,[]]"
      ~?= Right (List [Num 1, List []])
  ]

tests =
  TestList $
    parseTests
      ++ []

main :: IO ()
main = do
  runTestTT tests
  return ()
