import Day15Lib (processInput1, processInput2)
import System.IO
import Test.HUnit

testCases1 =
  [ ("data/input150.txt", 10, 26),
    ("data/input151.txt", 2000000, 5083287)
  ]

testCase1 (file, ylevel, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual "input test" result $ processInput1 ylevel contents
    )

testCases2 =
  [ ("data/input150.txt", 20, 56000011),
    ("data/input151.txt", 4000000, 13134039205729)
  ]

testCase2 (file, r, result) = do
  withFile
    file
    ReadMode
    ( \handle -> do
        contents <- hGetContents handle
        assertEqual ("input test: " ++ file) result $ processInput2 r contents
    )

tests =
  TestList $
    [TestCase (testCase1 c) | c <- testCases1]
      ++ [TestCase (testCase2 c) | c <- testCases2]

main :: IO ()
main = do
  runTestTT tests
  return ()
